var sourceContent, resultContent, htmlExport;



// -----------------------------------------------------------------------------
// to use localStorage of HTML5 for saving the "source" div on the fly, if the browser/tab is closed data will remain saved until the browser's cache is deleted ... 

var editor = document.getElementById("source");
if (window.localStorage["TextEditorData"]) {
	editor.value = window.localStorage["TextEditorData"];	// retrieves the source code from the browser's cache even after the browser/tab is reopened
}
var inactivityPeriod;
editor.addEventListener("keyup", function() {
	//console.log('Textarea Change');
	clearTimeout(inactivityPeriod);			// resets "inactivityPeriod" because a change has been captured
	inactivityPeriod = setTimeout(function() {	// Runs 1 second (1000 ms) after the last change
		window.localStorage["TextEditorData"] = editor.value;	// stores the source code after 1s pause after each keyup
		setTimeout(function() {
			document.getElementById('save-log').style.display = 'inline-block';	// Runs 1 second (1000 ms) after the last change
		}, 1000);
		setTimeout(function() {
			document.getElementById('save-log').style.display = 'none';	// Runs 1 second (1000 ms) after the last change
		}, 2000);
	}, 1000);
});



// -----------------------------------------------------------------------------
// for finding the present date in Persian Calendar

function gregorian_to_jalali(gy,gm,gd){
	g_d_m=[0,31,59,90,120,151,181,212,243,273,304,334];
	jy=(gy<=1600)?0:979;
	gy-=(gy<=1600)?621:1600;
	gy2=(gm>2)?(gy+1):gy;
	days=(365*gy) +(parseInt((gy2+3)/4)) -(parseInt((gy2+99)/100)) +(parseInt((gy2+399)/400)) -80 +gd +g_d_m[gm-1];
	jy+=33*(parseInt(days/12053)); 
	days%=12053;
	jy+=4*(parseInt(days/1461));
	days%=1461;
	jy+=parseInt((days-1)/365);
 	if(days > 365)days=(days-1)%365;
	jm=(days < 186)?1+parseInt(days/31):7+parseInt((days-186)/30);
	jd=1+((days < 186)?(days%31):((days-186)%30));
	return [jy,jm,jd];
};
var persianMonth=["","فروردین","اردیبهشت","خرداد","تیر","مرداد","شهریور","مهر","آبان","آذر","دی","بهمن","اسفند"];
var morningAfternnon;
function persianDateTime(){
	d=new Date();
	g_y=d.getFullYear();
	g_m=d.getMonth()+1;
	g_d=d.getDate();
	shamsi=gregorian_to_jalali(g_y,g_m,g_d);
	H=d.getHours();
	//H=(H<10)?"0"+H:H;
	morningAfternnon= 
		(H==12)  ? "ظهر" : (
			(H!=0) ? (
				(H<12) ? "صبح" : (
					(H>=20) ? "شب" :  "بعد از ظهر"
				)
			)
			: "نیمه‌شب"
		);
	/*if(H==12){
		morningAfternnon="ظهر";
	}else if(H==0){
		morningAfternnon="نیمه‌شب";
	}else if(H<12 && H!=0){
		morningAfternnon="صبح";
	}else if(H>20){
		morningAfternnon="شب";
	}else{
		morningAfternnon="بعد از ظهر";
	}*/
	H = (H<=12)  ?  H  :  H-12;
	H = (H<10) ? "0"+H : H;
	i = d.getMinutes();
	i = (i<10) ? "0"+i : i;
	//s=d.getSeconds();
	//s=(s<10)?"0"+s:s;
	//return shamsi[0]+"-"+persianMonth[shamsi[1]]+"-"+shamsi[2]+"("+H+" "+i+")";
	return "("+shamsi[0]+"٫"+shamsi[1]+"٫"+shamsi[2]+" ساعت "+H+":"+i+" "+morningAfternnon+")";	// "نسخه‌ی "+shamsi[2]+" "+persianMonth[shamsi[1]]+" "+shamsi[0]+" ساعت "+H+" و "+i+" دقیقه‌ی "+morningAfternnon;
};
// now you can use the present date by calling the function  persianDateTime()



// -----------------------------------------------------------------------------
// now we provide the compile() function to compile the source code and produce the result

// first let add the shortcut "shift+enter" as an alternative for clicking the "compile button"
document.getElementById("source").addEventListener("keydown", function(e) {
	if (e.shiftKey && e.keyCode == 13) { e.preventDefault(); compile(); }
});
// now define the action of the compile button
function compile(){
	sourceContent=document.getElementById("source").value;   //.innerHTML; if using a contenteditable=true div

	var ftnNum=0;
	
	resultContent=sourceContent
		// تایپ اسلامی
		.replace(/(\(الله\))/g,"<img src='../0_main/images/glyph/1.png' style='height:17px;'>")
		.replace(/(\(محمد\))/g,"<img src='../0_main/images/glyph/2.png' style='height:14px'>")
		.replace(/(\(علی\))/g,"<img src='../0_main/images/glyph/3.png' style='height:21px;'>")
		.replace(/(\(جل\))/g,"<img src='../0_main/images/glyph/4.png' style='height:17px;'>")
		.replace(/(\(ص\))/g,"<img src='../0_main/images/glyph/5.png' style='height:21px;'>")
		.replace(/(\(علیه\))/g,"<img src='../0_main/images/glyph/6.png' style='height:14px;'>")
		.replace(/(\(علیها\))/g,"<img src='../0_main/images/glyph/7.png' style='height:21px;'>")
		.replace(/(\(علیهما\))/g,"<img src='../0_main/images/glyph/8.png' style='height:21px;'>")
		.replace(/(\(علیهم\))/g,"<img src='../0_main/images/glyph/9.png' style='height:21px;'>")
		.replace(/(\(عج\))/g,"<img src='../0_main/images/glyph/10.png' style='height:21px;'>")
		.replace(/(\(رحمه\))/g,"<img src='../0_main/images/glyph/11.png' style='height:21px;'>")
		.replace(/(\(رحمهما\))/g,"<img src='../0_main/images/glyph/12.png' style='height:21px;'>")
		.replace(/(\(رحمهم\))/g,"<img src='../0_main/images/glyph/13.png' style='height:21px;'>")
		.replace(/(\(سره\))/g,"<img src='../0_main/images/glyph/14.png' style='height:21px;'>")
		.replace(/(\(سرهما\))/g,"<img src='../0_main/images/glyph/15.png' style='height:21px;'>")
		.replace(/(\(سرهم\))/g,"<img src='../0_main/images/glyph/16.png' style='height:21px;'>")
		.replace(/(\(ظله\))/g,"<img src='../0_main/images/glyph/17.png' style='height:21px;'>")
		/*
		.replace(/(\(الله\))/g,"<span style='font-family:Moalla'>اللّه</span>")
		.replace(/(\(محمد\))/g,"<span style='font-family:Moalla'>مُحَمَّد</span>")
		.replace(/(\(علی\))/g,"<span style='font-family:Moalla'>عَلی</span>")
		.replace(/(\(جل\))/g,"<span style='font-family:Moalla'>«جَلّ‌َجَلالُه»</span>")
		.replace(/(\(ص\))/g,"<span style='font-family:Moalla'>«صَلَّی‌اللّه‌ُعَلَیْه‌ِوَآلِه»</span>")
		.replace(/(\(علیه\))/g,"<span style='font-family:Moalla'>«عَلَیْه‌ِالسَّلام»</span>")
		.replace(/(\(علیها\))/g,"<span style='font-family:Moalla'>«عَلَیْهاالسَّلام»</span>")
		.replace(/(\(علیهما\))/g,"<span style='font-family:Moalla'>«عَلَیْهِماالسَّلام»</span>")
		.replace(/(\(علیهم\))/g,"<span style='font-family:Moalla'>«عَلَیْهِم‌ُالسَّلام»</span>")
		.replace(/(\(عج\))/g,"<span style='font-family:Moalla'>«عَجّ‌َاللّه‌ُفَرَجَه‌ُالشَّریف»</span>")
		.replace(/(\(رحمه\))/g,"<span style='font-family:Moalla'>«رَحِمَه‌ُاللّه»</span>")
		.replace(/(\(رحمها\))/g,"<span style='font-family:Moalla'>«رَحِمَهااللّه»</span>")
		.replace(/(\(رحمهما\))/g,"<span style='font-family:Moalla'>«رَحِمَهُمااللّه»</span>")
		.replace(/(\(رحمهم\))/g,"<span style='font-family:Moalla'>«رَحِمَهُم‌ُاللّه»</span>")
		.replace(/(\(سره\))/g,"<span style='font-family:Moalla'>«قُدِّس‌َسِرُّه»</span>")
		.replace(/(\(سرها\))/g,"<span style='font-family:Moalla'>«قُدِّس‌َسِرُّها»</span>")
		.replace(/(\(سرهما\))/g,"<span style='font-family:Moalla'>«قُدِّس‌َسِرُّهُما»</span>")
		.replace(/(\(سرهم\))/g,"<span style='font-family:Moalla'>«قُدِّس‌َسِرُّهُم»</span>")
		.replace(/(\(ظله\))/g,"<span style='font-family:Moalla'>«دامَّ‌ظِلُّه»</span>")
		*/
		.replace(/(\/اسلیمی۱\/)/g,"<img src='../0_main/images/glyph/18.png' style='height:21px;'>")
		.replace(/(\/اسلیمی۲\/)/g,"<img src='../0_main/images/glyph/18-00.png' style='height:21px;'>")
		.replace(/(\/اسلیمی۳\/)/g,"<img src='../0_main/images/glyph/18-0.png' style='height:21px;'>")
		.replace(/(\/اسلیمی۴\/)/g,"<img src='../0_main/images/glyph/18-1.png' style='height:21px;'>")
		.replace(/(\/اسلیمی۵\/)/g,"<img src='../0_main/images/glyph/18-2.png' style='height:21px;'>")
		.replace(/(\/اسلیمی۶\/)/g,"<img src='../0_main/images/glyph/18-3.png' style='height:21px;'>")
		.replace(/(\/اسلیمی۷\/)/g,"<img src='../0_main/images/glyph/18-4.png' style='height:21px;'>")
		.replace(/(\/اسلیمی۸\/)/g,"<img src='../0_main/images/glyph/18-5.png' style='height:21px;'>")
		.replace(/(\/اسلیمی۹\/)/g,"<img src='../0_main/images/glyph/18-6.png' style='height:21px;'>")
		.replace(/(\/اسلیمی۱۰\/)/g,"<img src='../0_main/images/glyph/18-7.png' style='height:21px;'>")
		.replace(/(\/اسلیمی۱۱\/)/g,"<img src='../0_main/images/glyph/18-8.png' style='height:21px;'>")
		.replace(/(\/اسلیمی۱۲\/)/g,"<img src='../0_main/images/glyph/18-9.png' style='height:21px;'>")
		.replace(/(\/اسلیمی۱۳\/)/g,"<img src='../0_main/images/glyph/18-10.png' style='height:21px;'>")
		.replace(/(\/اسلیمی۱۴\/)/g,"<img src='../0_main/images/glyph/18-11.png' style='height:21px;'>")
		.replace(/(\/اسلیمی۱۵\/)/g,"<img src='../0_main/images/glyph/18-12.png' style='height:21px;'>")
		.replace(/(\/خط۱\/)/g,"<img src='../0_main/images/glyph/19.png' style='width:200px;'>")
		.replace(/(\/خط۲\/)/g,"<img src='../0_main/images/glyph/19-0.png'>")
		.replace(/(\/خط۳\/)/g,"<img src='../0_main/images/glyph/19-1.png'>")
		.replace(/(\/خط۴\/)/g,"<img src='../0_main/images/glyph/19-2.png'>")
		.replace(/(\/خط۵\/)/g,"<img src='../0_main/images/glyph/19-3.png'>")
		.replace(/(\/خط۶\/)/g,"<img src='../0_main/images/glyph/19-4.png'>")
		.replace(/(\/خط۷\/)/g,"<img src='../0_main/images/glyph/19-5.png'>")
		.replace(/(\/خط۸\/)/g,"<img src='../0_main/images/glyph/19-6.png'>")
		.replace(/(\/خط۹\/)/g,"<img src='../0_main/images/glyph/19-7.png'>")
		.replace(/(\/خط۱۰\/)/g,"<img src='../0_main/images/glyph/19-8.png'>")
		.replace(/(\/خط۱۱\/)/g,"<img src='../0_main/images/glyph/19-9.png'>")
		.replace(/(\/خط۱۲\/)/g,"<img src='../0_main/images/glyph/19-10.png'>")
		.replace(/(\/خط۱۳\/)/g,"<img src='../0_main/images/glyph/20-1.png'>")
		.replace(/(\/خط۱۴\/)/g,"<img src='../0_main/images/glyph/20-5.png'>")
		.replace(/(\/خط۱۵\/)/g,"<img src='../0_main/images/glyph/20-6.png'>")
		.replace(/(\/خط۱۶\/)/g,"<img src='../0_main/images/glyph/20-7.png'>")
		.replace(/(\/خط۱۷\/)/g,"<img src='../0_main/images/glyph/20-8.png'>")
		.replace(/(\/خط۱۸\/)/g,"<img src='../0_main/images/glyph/20-9.png'>")
		.replace(/(\/خط۱۹\/)/g,"<img src='../0_main/images/glyph/20-10.png'>")
		.replace(/(\/خط۲۰\/)/g,"<img src='../0_main/images/glyph/20-11.png'>")
		.replace(/(\/خط۲۱\/)/g,"<img src='../0_main/images/glyph/20-12.png'>")
		.replace(/(\/خط۲۲\/)/g,"<img src='../0_main/images/glyph/20-13.png'>")
		.replace(/(\/خط۲۳\/)/g,"<img src='../0_main/images/glyph/20-14.png'>")
		.replace(/(\/خط۲۴\/)/g,"<img src='../0_main/images/glyph/20-15.png'>")
		.replace(/(\/خط۲۵\/)/g,"<img src='../0_main/images/glyph/20-16.png'>")
		.replace(/(\/خط۲۶\/)/g,"<img src='../0_main/images/glyph/20-17.png'>")
		.replace(/(\/خط۲۷\/)/g,"<img src='../0_main/images/glyph/20-20.png'>")
		.replace(/(\/خط۲۸\/)/g,"<img src='../0_main/images/glyph/20-19.png'>")
		.replace(/(\/خط۲۹\/)/g,"<img src='../0_main/images/glyph/20-18.png'>")
		.replace(/(\/تزئين۱\/)/g,"<img src='../0_main/images/glyph/21-1.png' style='height:21px;'>")
		.replace(/(\/تزئين۲\/)/g,"<img src='../0_main/images/glyph/21-2.png' style='height:21px;'>")
		.replace(/(\/تزئين۳\/)/g,"<img src='../0_main/images/glyph/21-3.png' style='height:21px;'>")
		.replace(/(\/تزئين۴\/)/g,"<img src='../0_main/images/glyph/21-4.png' style='height:50px;'>")
		
		// شکلک‌ها (smiley)
		.replace(/(\(ش۱\))/g, "<img src='../0_main/images/smiley/001.gif'>")
		.replace(/(\(ش۲\))/g, "<img src='../0_main/images/smiley/002.gif'>")
		.replace(/(\(ش۳\))/g, "<img src='../0_main/images/smiley/003.gif'>")
		.replace(/(\(ش۴\))/g, "<img src='../0_main/images/smiley/004.gif'>")
		.replace(/(\(ش۵\))/g, "<img src='../0_main/images/smiley/005.gif'>")
		.replace(/(\(ش۶\))/g, "<img src='../0_main/images/smiley/006.gif'>")
		.replace(/(\(ش۷\))/g, "<img src='../0_main/images/smiley/007.gif'>")
		.replace(/(\(ش۸\))/g, "<img src='../0_main/images/smiley/008.gif'>")
		.replace(/(\(ش۹\))/g, "<img src='../0_main/images/smiley/009.gif'>")
		.replace(/(\(ش۱۰\))/g,"<img src='../0_main/images/smiley/010.gif'>")
		.replace(/(\(ش۱۱\))/g,"<img src='../0_main/images/smiley/011.gif'>")
		.replace(/(\(ش۱۲\))/g,"<img src='../0_main/images/smiley/012.gif'>")
		.replace(/(\(ش۱۳\))/g,"<img src='../0_main/images/smiley/013.gif'>")
		.replace(/(\(ش۱۴\))/g,"<img src='../0_main/images/smiley/014.gif'>")
		.replace(/(\(ش۱۵\))/g,"<img src='../0_main/images/smiley/015.gif'>")
		.replace(/(\(ش۱۶\))/g,"<img src='../0_main/images/smiley/016.gif'>")
		.replace(/(\(ش۱۷\))/g,"<img src='../0_main/images/smiley/017.gif'>")
		.replace(/(\(ش۱۸\))/g,"<img src='../0_main/images/smiley/018.gif'>")
		.replace(/(\(ش۱۹\))/g,"<img src='../0_main/images/smiley/019.gif'>")
		.replace(/(\(ش۲۰\))/g,"<img src='../0_main/images/smiley/020.gif'>")		
		.replace(/(\(ش۲۱\))/g, "<img src='../0_main/images/smiley/021.gif'>")
		.replace(/(\(ش۲۲\))/g, "<img src='../0_main/images/smiley/022.gif'>")
		.replace(/(\(ش۲۳\))/g, "<img src='../0_main/images/smiley/023.gif'>")
		.replace(/(\(ش۲۴\))/g, "<img src='../0_main/images/smiley/024.gif'>")
		.replace(/(\(ش۲۵\))/g, "<img src='../0_main/images/smiley/025.gif'>")
		.replace(/(\(ش۲۶\))/g, "<img src='../0_main/images/smiley/026.gif'>")
		.replace(/(\(ش۲۷\))/g, "<img src='../0_main/images/smiley/027.gif'>")
		.replace(/(\(ش۲۸\))/g, "<img src='../0_main/images/smiley/028.gif'>")
		.replace(/(\(ش۲۹\))/g, "<img src='../0_main/images/smiley/029.gif'>")
		.replace(/(\(ش۳۰\))/g,"<img src='../0_main/images/smiley/030.gif'>")
		.replace(/(\(ش۳۱\))/g,"<img src='../0_main/images/smiley/031.gif'>")
		.replace(/(\(ش۳۲\))/g,"<img src='../0_main/images/smiley/032.gif'>")
		.replace(/(\(ش۳۳\))/g,"<img src='../0_main/images/smiley/033.gif'>")
		.replace(/(\(ش۳۴\))/g,"<img src='../0_main/images/smiley/034.gif'>")
		.replace(/(\(ش۳۵\))/g,"<img src='../0_main/images/smiley/035.gif'>")
		.replace(/(\(ش۳۶\))/g,"<img src='../0_main/images/smiley/036.gif'>")
		.replace(/(\(ش۳۷\))/g,"<img src='../0_main/images/smiley/037.gif'>")
		.replace(/(\(ش۳۸\))/g,"<img src='../0_main/images/smiley/038.gif' style='height:70px;'>")
		.replace(/(\(ش۳۹\))/g,"<img src='../0_main/images/smiley/039.gif'>")
		.replace(/(\(ش۴۰\))/g,"<img src='../0_main/images/smiley/040.gif'>")
		.replace(/(\(ش۴۱\))/g,"<img src='../0_main/images/smiley/041.gif'>")
		.replace(/(\(ش۴۲\))/g,"<img src='../0_main/images/smiley/042.gif'>")
		.replace(/(\(ش۴۳\))/g,"<img src='../0_main/images/smiley/043.gif'>")
		.replace(/(\(ش۴۴\))/g,"<img src='../0_main/images/smiley/044.gif'>")
		.replace(/(\(ش۴۵\))/g,"<img src='../0_main/images/smiley/045.gif'>")
		.replace(/(\(ش۴۶\))/g,"<img src='../0_main/images/smiley/046.gif'>")
		.replace(/(\(ش۴۷\))/g,"<img src='../0_main/images/smiley/047.gif'>")
		.replace(/(\(ش۴۸\))/g,"<img src='../0_main/images/smiley/048.gif'>")
		.replace(/(\(ش۴۹\))/g,"<img src='../0_main/images/smiley/049.gif'>")
		.replace(/(\(ش۵۰\))/g,"<img src='../0_main/images/smiley/050.gif'>")
		.replace(/(\(ش۵۱\))/g,"<img src='../0_main/images/smiley/051.gif'>")
		.replace(/(\(ش۵۲\))/g,"<img src='../0_main/images/smiley/052.gif' style='height:45px;'>")
		.replace(/(\(ش۵۳\))/g,"<img src='../0_main/images/smiley/053.gif' style='height:45px;'>")
		.replace(/(\(ش۵۴\))/g,"<img src='../0_main/images/smiley/054.gif'>")
		.replace(/(\(ش۵۵\))/g,"<img src='../0_main/images/smiley/055.gif'>")
		.replace(/(\(ش۵۶\))/g,"<img src='../0_main/images/smiley/056.gif'>")
		.replace(/(\(ش۵۷\))/g,"<img src='../0_main/images/smiley/057.gif'>")
		.replace(/(\(ش۵۸\))/g,"<img src='../0_main/images/smiley/058.gif'>")
		.replace(/(\(ش۵۹\))/g,"<img src='../0_main/images/smiley/059.gif'>")
		.replace(/(\(ش۶۰\))/g,"<img src='../0_main/images/smiley/060.gif'>")
		.replace(/(\(ش۶۱\))/g,"<img src='../0_main/images/smiley/061.gif'>")
		.replace(/(\(ش۶۲\))/g,"<img src='../0_main/images/smiley/062.gif'>")
		.replace(/(\(ش۶۳\))/g,"<img src='../0_main/images/smiley/063.gif'>")
		.replace(/(\(ش۶۴\))/g,"<img src='../0_main/images/smiley/064.gif'>")
		.replace(/(\(ش۶۵\))/g,"<img src='../0_main/images/smiley/065.gif'>")
		.replace(/(\(ش۶۶\))/g,"<img src='../0_main/images/smiley/066.gif'>")
		.replace(/(\(ش۶۷\))/g,"<img src='../0_main/images/smiley/067.gif'>")
		.replace(/(\(ش۶۸\))/g,"<img src='../0_main/images/smiley/068.gif'>")
		.replace(/(\(ش۶۹\))/g,"<img src='../0_main/images/smiley/069.gif'>")
		.replace(/(\(ش۷۰\))/g,"<img src='../0_main/images/smiley/070.gif'>")
		.replace(/(\(ش۷۱\))/g,"<img src='../0_main/images/smiley/071.gif'>")
		.replace(/(\(ش۷۲\))/g,"<img src='../0_main/images/smiley/072.gif'>")
		.replace(/(\(ش۷۳\))/g,"<img src='../0_main/images/smiley/073.gif'>")
		.replace(/(\(ش۷۴\))/g,"<img src='../0_main/images/smiley/074.gif'>")
		.replace(/(\(ش۷۵\))/g,"<img src='../0_main/images/smiley/075.gif'>")
		.replace(/(\(ش۷۶\))/g,"<img src='../0_main/images/smiley/b01.gif'>")
		.replace(/(\(ش۷۷\))/g,"<img src='../0_main/images/smiley/b02.gif'>")
		.replace(/(\(ش۷۸\))/g,"<img src='../0_main/images/smiley/b03.gif'>")
		.replace(/(\(ش۷۹\))/g,"<img src='../0_main/images/smiley/b04.gif'>")
		.replace(/(\(ش۸۰\))/g,"<img src='../0_main/images/smiley/b05.gif'>")
		.replace(/(\(ش۸۱\))/g,"<img src='../0_main/images/smiley/b06.gif'>")
		.replace(/(\(ش۸۲\))/g,"<img src='../0_main/images/smiley/b07.gif'>")
		.replace(/(\(ش۸۳\))/g,"<img src='../0_main/images/smiley/b08.gif'>")
		.replace(/(\(ش۸۴\))/g,"<img src='../0_main/images/smiley/b09.gif'>")
		.replace(/(\(ش۸۵\))/g,"<img src='../0_main/images/smiley/b10.gif'>")
		.replace(/(\(ش۸۶\))/g,"<img src='../0_main/images/smiley/b11.gif'>")
		.replace(/(\(ش۸۷\))/g,"<img src='../0_main/images/smiley/b12.gif'>")
		.replace(/(\(ش۸۸\))/g,"<img src='../0_main/images/smiley/b13.gif'>")
		.replace(/(\(ش۸۹\))/g,"<img src='../0_main/images/smiley/b14.gif'>")
		.replace(/(\(ش۹۰\))/g,"<img src='../0_main/images/smiley/b15.gif'>")
		.replace(/(\(ش۹۱\))/g,"<img src='../0_main/images/smiley/b16.gif'>")
		.replace(/(\(ش۹۲\))/g,"<img src='../0_main/images/smiley/b17.gif'>")
		.replace(/(\(ش۹۳\))/g,"<img src='../0_main/images/smiley/b18.gif' style='height:50px;'>")
		.replace(/(\(ش۹۴\))/g,"<img src='../0_main/images/smiley/b19.gif'>")
		.replace(/(\(ش۹۵\))/g,"<img src='../0_main/images/smiley/b20.gif' style='height:50px;'>")
		
		.replace(/(\/؟\/)/g,"<img src='../0_main/images/smiley/ex01.gif' style='height:21px;'>")
		.replace(/(\/!\/)/g,"<img src='../0_main/images/smiley/ex02.gif' style='height:21px;'>")
		.replace(/(\/!!\/)/g,"<img src='../0_main/images/smiley/ex03.gif' style='height:21px;'>")
		.replace(/(\/چپ\/)/g,"<img src='../0_main/images/smiley/ex04.gif' style='height:21px;'>")
		.replace(/(\/راست\/)/g,"<img src='../0_main/images/smiley/ex05.gif' style='height:21px;'>")
		.replace(/(\/لامپ\/)/g,"<img src='../0_main/images/smiley/ex06.gif' style='height:21px;'>")
		.replace(/(\/شمع\/)/g,"<img src='../0_main/images/smiley/ex07.gif' style='height:21px;'>")
		.replace(/(\/گل\/)/g,"<img src='../0_main/images/smiley/ex08.gif' style='height:21px;'>")
		.replace(/(\/قلب\/)/g,"<img src='../0_main/images/smiley/ex09.gif' style='height:21px;'>")
		.replace(/(\/بادکنک\/)/g,"<img src='../0_main/images/smiley/ex10.gif' style='height:26px;'>")
		.replace(/(\/کبوتر\/)/g,"<img src='../0_main/images/smiley/ex11.gif' style='height:26px;'>")
		.replace(/(\/پروانه\/)/g,"<img src='../0_main/images/smiley/ex12.gif' style='height:21px;'>")
		.replace(/(\/قهوه\/)/g,"<img src='../0_main/images/smiley/ex13.gif' style='height:21px;'>")
		
		
		// Bold,Italic, Underline, Linetrough, ...
		.replace(/(××)[ \t\n]*(?=\S)([^\r]*?\S[*_]*)[ \t\n]*\1/g,"<strong>$2</strong>")
		.replace(/(×)[ \t\n]*(?=\S)([^\r]*?\S)[ \t\n]*\1/g,"<em>$2</em>")
		.replace(/(\/ـ\/)[ \t\n]*(?=\S)([^\r]*?\S)[ \t\n]*\1/g,"<u>$2</u>")
		.replace(/(\/-\/)[ \t\n]*(?=\S)([^\r]*?\S)[ \t\n]*\1/g,"<s>$2</s>")
				
		.replace(/(\/،\/)[ \t\n]*(?=\S)([^\r]*?\S)[ \t\n]*\1/g,"<sub>$2</sub>")
		.replace(/(\/٬\/)[ \t\n]*(?=\S)([^\r]*?\S)[ \t\n]*\1/g,"<sup>$2</sup>")
		
		.replace(/(\/ق\/)[ \t\n]*(?=\S)([^\r]*?\S)[ \t\n]*\1/g,"<span style='color:rgb(220,20,60)'>$2</span>")
		.replace(/(\/آ\/)[ \t\n]*(?=\S)([^\r]*?\S)[ \t\n]*\1/g,"<span style='color:rgb(0,0,139)'>$2</span>")
		.replace(/(\/ط\/)[ \t\n]*(?=\S)([^\r]*?\S)[ \t\n]*\1/g,"<span style='color:rgb(189,158,85)'>$2</span>")
		
		.replace(/(\/ز\/)[ \t\n]*(?=\S)([^\r]*?\S)[ \t\n]*\1/g,"<span style='background-color:yellow'>$2</span>")
		.replace(/(\/س\/)[ \t\n]*(?=\S)([^\r]*?\S)[ \t\n]*\1/g,"<span style='background-color:lime'>$2</span>")
		
		.replace(/(\/ث\/)[ \t\n]*(?=\S)([^\r]*?\S)[ \t\n]*\1/g,"<span style='font-family:Sols'>$2</span>")
		.replace(/(\/غ\/)[ \t\n]*(?=\S)([^\r]*?\S)[ \t\n]*\1/g,"<span style='font-family:Ghazali'>$2</span>")
		.replace(/(\/م\/)[ \t\n]*(?=\S)([^\r]*?\S)[ \t\n]*\1/g,"<span style='font-family:Moalla'>$2</span>")
		.replace(/(\/د\/)[ \t\n]*(?=\S)([^\r]*?\S)[ \t\n]*\1/g,"<span style='font-family:Dast'>$2</span>")		
		.replace(/(\/C\/)[ \t\n]*(?=\S)([^\r]*?\S)[ \t\n]*\1/g,"<span style='font-family:Callahan'>$2</span>")
		.replace(/(\/Z\/)[ \t\n]*(?=\S)([^\r]*?\S)[ \t\n]*\1/g,"<span style='font-family:Zapfino; font-size:60%; decoration:strong;'>$2</span>")
		
		.replace(/(\/قرآن\/)[ \t\n]*(?=\S)([^\r]*?\S)[ \t\n]*\1/g,"<span style='font-family:Neirizi; font-size:100%; color:rgb(34,139,34); text-shadow:2px 2px 4px white;'>$2</span>")
		.replace(/(\/حدیث\/)[ \t\n]*(?=\S)([^\r]*?\S)[ \t\n]*\1/g,"<span style='font-family:Neirizi; font-size:90%; color:rgb(65,105,225); text-shadow:2px 2px 4px white;'>$2</span>")
		.replace(/(\/ترجمه\/)[ \t\n]*(?=\S)([^\r]*?\S)[ \t\n]*\1/g,"<span style='font-family:IranNastaliq; font-size:140%; color:rgb(205,92,92); text-shadow:2px 2px 4px white;'>$2</span>")
		
		.replace(/(\/ک\/)[ \t\n]*(?=\S)([^\r]*?\S)[ \t\n]*\1/g,"<span style='font-size:x-small'>$2</span>")
		.replace(/(\/ب\/)[ \t\n]*(?=\S)([^\r]*?\S)[ \t\n]*\1/g,"<span style='font-size:x-large'>$2</span>")
		
		.replace(/!\([ \t]*()<?(\S+?)>?(?: =([*\d]+[A-Za-z%]{0,4})x([*\d]+[A-Za-z%]{0,4}))?[ \t]*(?:(['"])(.*?)\5[ \t]*)?\)/g,"<img src='$2' width='$3' height='$4' title='$6'>") //use as  !(sample/1.gif =300x200 "توضیحات")
		
		.replace(/(\[((?:\[[^\]]*]|[^\[\]])*)]\([ \t]*()<?(.*?(?:\(.*?\).*?)?)>?[ \t]*((['"])(.*?)\6[ \t]*)?\))/g,"<a href='$4' title='$7'>$2</a>")   //use as  [لینک](http://www.address "توضیحات")
		
		.replace(/[ \t]*\n{0}(\/ن\/)[ \t\n]*(?=\S)([^\r]*?\S)[ \t\n]*\1/g,"<blockquote>$2</blockquote>")
		.replace(/[ \t]*\n{0,1}(\/ی\/)[ \t\n]*(?=\S)([^\r]*?\S)[ \t\n]*\1/g,"<!-- $2 -->")
		
		// for capturing the title and subtitle of the notebook (the main title will be used as name of the file)
		.replace(/[ \t]*\n{0,1}(?:\/ع\/)[ \t]*(.+?)[ \t]*$/gm,"<vskip><div style='text-align:center; font-family:Sols; font-size:130%; decoration:strong; color:darkgreen; text-shadow:4px 4px 8px white;'>«<span id='title'>$1</span>»</div><vskip>")
		.replace(/[ \t]*\n{0,1}(?:\/ز.ع\/)[ \t]*(.+?)[ \t]*$/gm,"<div style='text-align:center; font-family:Sols; font-size:90%; decoration:strong; color:darkgreen; text-shadow:4px 4px 8px white;'>$1</div><vskip>")
		
		// for capturing the date of the last revision: today, now
		.replace(/(?:\/تاریخ\/)/g,"<span style='font-size:80%; color:darkgreen;' id='today'></span>")
		
		// for capturing the name of the author
		.replace(/[ \t]*\n{0,1}(?:\/نویسنده\/)[ \t]*(.+?)(?:[ \t]*$)/gm,"<vskip><div style='text-align:center; font-size:90%; color:darkgreen;'>$1</div><vskip>")
		
		// for capturing the table of content
		.replace(/(\/فهرست\/)/g,"<vskip><div id='toc'></div><vskip>")
		
		// for capturing "headings" in three levels "h1", "h2" and "h3"
		//.replace(/(#)(?=\S)([^\r]*?\S)\1/g,"<h1>$2</h1>")
		//.replace(/[ \t]*\n{0}(\/ت۱\/)[ \t]*(.+?)[ \t]*\n+/gm,"<h1>$2</h1>")
		.replace(/(?:^[ \t]*\/ت۱\/|\n[ \t]*\/ت۱\/)[ \t]*(.+?)(?:[ \t]*$)/gm, "<vskip><p class='header' kind='h1'>$1<p>")
		//.replace(/(\/ت۲\/)(?=\S)([^\r]*?\S)\1/g,"<h2>$2</h2>")
		//.replace(/(?:^[ \t]*\/ت۲\/|\n[ \t]*\/ت۲\/)[ \t]*(.+?)(?:[ \t]*$)/gm,"<vskip><br><span style='color:#B22222; font-size:x-large; font-weight: bold; text-shadow: 0.1px 0.1px 0.1px crimson;'>$1</span><br>")
		.replace(/(?:^[ \t]*\/ت۲\/|\n[ \t]*\/ت۲\/)[ \t]*(.+?)(?:[ \t]*$)/gm, "<vskip><p class='header' kind='h2'>$1<p>")
		//.replace(/(\/ت۳\/)(?=\S)([^\r]*?\S)\1/g,"<h3>$2</h3>")
		.replace(/(?:^[ \t]*\/ت۳\/|\n[ \t]*\/ت۳\/)[ \t]*(.+?)(?:[ \t]*$)/gm, "<vskip><p class='header' kind='h3'>$1<p>")
		
		// for capturing footnotes, or actually endnotes, the source being like [٬٬ text ٬٬]
		.replace(/(?:\[٬٬)[ \t\n]*([.\s\S]*?)[ \t\n]*(?:٬٬\])/g, function(x,y){
			ftnNum++;
			var ftnNumPersian=ftnNum.toString().replace(/0/g,'۰').replace(/1/g,'۱').replace(/2/g,'۲').replace(/3/g,'۳').replace(/4/g,'۴').replace(/5/g,'۵').replace(/6/g,'۶').replace(/7/g,'۷').replace(/8/g,'۸').replace(/9/g,'۹');
			return "<sup>"
					+"<a href='#FTN-"+ftnNum+"' id='ftn-"+ftnNum+"' style='font-size:90%; color:crimson;' onMouseOver='showFootnoteInline("+ftnNum+");' onMouseOut='hideFootnoteInline("+ftnNum+");'>"
						+ftnNumPersian
					+"</a>"
					+"<span id='ftnHidden-"+ftnNum+"' hidden>"+y+"</span>"
				+"</sup>"
				+" <span id='ftnInlineHidden-"+ftnNum+"' style='display:none; font-size:100%; color:crimson;'>\{<span style='font-size:80%; color:grey;'>"+y+"</span>\}</span>";
		})
		
		
		
		// for capturing citation to references, each reference had been given a key before ...
		.replace(/(?:\/ارجاع)(?:\[[ \t]*(.*?)[ \t]*\]*)?(?:\{[ \t]*(.*?)[ \t]*\})/g,"<my-citation description='$1'>$2</my-citation>")   //use as  /ارجاع[description]{key}   and    /ارجاع[]{key}   or   /ارجاع{key}   if the citations doesn't need further description
		
		// for capturing the definition of the references, each reference should at least have a key and the body data
		/*
		.replace(/(?:\/مرجع)(?:\{[ \t]*(.*?)[ \t]*\})(?:\[[ \t]*(.*?)[ \t]*\])?(?:\[[ \t]*(.*?)[ \t]*\])?(?:\{[ \t]*(.*?)[ \t]*\})/g,"<ol class='ref'><li id='$1' author='$2' year='$3'>$4</li></ol>")   //use as    /مرجع{key}[shorten author: optional][year: optional]{full reference details}      or     /مرجع{key}{full reference details}    or    ....
		.replace(/(\<\/ol\>\s?\<ol class=\'ref\'\>)/g,"")
		*/
		.replace(/[ \t\n]*(?:\/مرجع)(?:\{[ \t]*(.*?)[ \t]*\})(?:\[نویسندگان:[ \t]*(.*?)[ \t]*\])?(?:\[عنوان:[ \t]*(.*?)[ \t]*\])?(?:\[ناشر:[ \t]*(.*?)[ \t]*\])?(?:\[سال:[ \t]*(.*?)[ \t]*\])?(?:\[توضیحات:[ \t]*(.*?)[ \t]*\])?(?:\[خلاصه:[ \t]*(.*?)[ \t]*\])?(?:\[زبان:[ \t]*(.*?)[ \t]*\])?[ \t\n]*/g,"<my-references  key='$1'  author='$2'  title='$3'  publisher='$4'  year='$5'  comment='$6'  shortRef='$7' language='$8'  style='display:none;'></my-references>")   //use it as    /مرجع{کلید}[نویسندگان: ...][عنوان: ...][ناشر: ...][سال: ..][توضیحات: ...][خلاصه: ...][زبان: ...] although each [] is optional ... 
		// for containing the list of references
		.replace(/(\/مراجع\/)/g,"<vskip><div id='listOfReferences'></div><vskip>")
		.replace(/(\/مراجع\*\/)/g,"<vskip><div id='listOfReferences' ordered='true'></div><vskip>")

		
		.replace(/٪(.*?)٪/g,"<code>$1</code>")  //"<pre><code>$1</code></pre>" this enters code in a newline
		
		// for capturing "ordered lists" and "un-ordered lists"
		.replace(/(^[ \t]*\*\*|\n[ \t]*\*\*)[ \t]*(.*)/g,"<ul><ul><li>$2</li></ul></ul>")
		.replace(/(^[ \t]*\*|\n[ \t]*\*)[ \t]*(.*)/g,"<ul><li>$2</li></ul>")
		.replace(/(\<\/ul\>\s?\<ul\>)/g,"").replace(/(\<\/ul\>\s?\<ul\>)/g,"")	// these were required twice
		.replace(/(^[ \t]*\+\+|\n[ \t]*\+\+)[ \t]*(.*)/g,"<ol><ol><li>$2</li></ol></ol>")
		.replace(/(^[ \t]*\+|\n[ \t]*\+)[ \t]*(.*)/g,"<ol><li>$2</li></ol>")
		.replace(/(\<\/ol\>\s?\<ol\>)/g,"").replace(/(\<\/ol\>\s?\<ol\>)/g,"")	// these were required twice
		
		// for capturing "tables"
		//optional, to use a pre-defined "class"
		//.replace(/(?:\|\|)[ \t]*\"(.*)\"[ \t]*\|(.*)(?:\|\|)\n*/g,"<table class='$1'><tr><td>$2</td></tr></table>")
		.replace(/(?:\|\|)[ \t]*\"(.*)\"[ \t]*$/gm,"<table class='$1'></table>")
		// to capture each complete row of a table with different optional styles for the first column
		.replace(/(?:^\|\|)([^\n]+)(?:\|\|$)/gm,"<table><tr><td>$1</td></tr></table>")	// default style
		.replace(/(?:^\|ر\|)([^\n]+)(?:\|\|$)/gm,"<table><tr><td style='text-align:right'>$1</td></tr></table>")
		.replace(/(?:^\|ر.ب\|)([^\n]+)(?:\|\|$)/gm,"<table><tr><td style=\"vertical-align:top; text-align:right;\">$1</td></tr></table>")
		.replace(/(?:^\|ر.پ\|)([^\n]+)(?:\|\|$)/gm,"<table><tr><td style=\"vertical-align:bottom; text-align:right;\">$1</td></tr></table>")
		.replace(/(?:^\|چ\|)([^\n]+)(?:\|\|$)/gm,"<table><tr><td style='text-align:left'>$1</td></tr></table>")
		.replace(/(?:^\|چ.ب\|)([^\n]+)(?:\|\|$)/gm,"<table><tr><td style=\"vertical-align:top; text-align:left;\">$1</td></tr></table>")
		.replace(/(?:^\|چ.پ\|)([^\n]+)(?:\|\|$)/gm,"<table><tr><td style=\"vertical-align:bottom; text-align:left;\">$1</td></tr></table>")
		.replace(/(?:^\|ب\|)([^\n]+)(?:\|\|$)/gm,"<table><tr><td style='vertical-align:top;'>$1</td></tr></table>")
		.replace(/(?:^\|پ\|)([^\n]+)(?:\|\|$)/gm,"<table><tr><td style='vertical-align:bottom;'>$1</td></tr></table>")
		// to capture each column in each row, with possible different optional styles for it
		.replace(/(\|\|)/g,"</td><td>")
		.replace(/(\|ر\|)/g,"</td><td style='text-align:right'>")
		.replace(/(\|ر.ب\|)/g,"</td><td style=\"vertical-align:top; text-align:right;\">")
		.replace(/(\|ر.پ\|)/g,"</td><td style=\"vertical-align:bottom; text-align:right;\">")
		.replace(/(\|چ\|)/g,"</td><td style='text-align:left'>")
		.replace(/(\|چ.ب\|)/g,"</td><td style=\"vertical-align:top; text-align:left;\">")
		.replace(/(\|چ.پ\|)/g,"</td><td style=\"vertical-align:bottom; text-align:left;\">")
		.replace(/(\|ب\|)/g,"</td><td style='vertical-align:top;'>")
		.replace(/(\|پ\|)/g,"</td><td style='vertical-align:bottom;'>")
		//to bind all the rows that are placed along each other to form a single styled table!
		.replace(/(\<\/table\>\s?\<table\>)/g,"")
		//to further polish the table by putting vertical spaces above and below a table
		.replace(/(\<table)/g,"<vskip><table")
		.replace(/(\<\/table\>)/g,"</table><vskip>")
		
		
				
		.replace(/[ \t]*\n{0}(---)[ \t]*\n{0,1}/g,"<hr>")
		
		.replace(/[ \t]*\n{0,1}(\/ت.چ\/)[ \t\n]*(?=\S)([^\r]*?\S)[ \t\n]*\1\n{0,1}/g,"<p style='text-align:left;'>$2</p>")
		.replace(/[ \t]*\n{0,1}(\/ت.ر\/)[ \t\n]*(?=\S)([^\r]*?\S)[ \t\n]*\1\n{0,1}/g,"<p style='text-align:right;'>$2</p>")
		.replace(/[ \t]*\n{0,1}(\/ت.و\/)[ \t\n]*(?=\S)([^\r]*?\S)[ \t\n]*\1\n{0,1}/g,"<p style='text-align:center;'>$2</p>")
		.replace(/[ \t]*\n{0,1}(\/ه.ت\/)[ \t\n]*(?=\S)([^\r]*?\S)[ \t\n]*\1\n{0,1}/g,"<p style='text-align:justify;'>$2</p>")
		.replace(/[ \t]*\n{0,1}(\/ج۱\/)[ \t\n]*(?=\S)([^\r]*?\S)[ \t\n]*\1\n{0,1}/g,"<p style='margin-right:40px;'>$2</p>")
		.replace(/[ \t]*\n{0,1}(\/ج۲\/)[ \t\n]*(?=\S)([^\r]*?\S)[ \t\n]*\1\n{0,1}/g,"<p style='margin-right:80px;'>$2</p>")
		
		.replace(/(\/ltr\/)[ \t\n]*(?=\S)([^\r]*?\S)[ \t\n]*\1/g,"<span dir='ltr'>$2</span>")
		.replace(/[ \t]*\n{0,1}(\/ltrp\/)[ \t\n]*(?=\S)([^\r]*?\S)[ \t\n]*\1\n{0,1}/g,"<p dir='ltr'>$2</p>")
		
		.replace(/(\\end\{align\})\n{0,1}/g,"\\end{align}")     // for suitable vertical spacing after "align" math eq.
		.replace(/\n/g,"<br>")

		.replace(/(\<vskip\>)/g,"<div style='height:10px;'></div>")
		;
		
		
	document.getElementById("result").innerHTML=resultContent;
	
	if(document.getElementById("today")){
		document.getElementById("today").innerHTML=persianDateTime().replace(/0/g,'۰').replace(/1/g,'۱').replace(/2/g,'۲').replace(/3/g,'۳').replace(/4/g,'۴').replace(/5/g,'۵').replace(/6/g,'۶').replace(/7/g,'۷').replace(/8/g,'۸').replace(/9/g,'۹');
	}
	
	
	// to handle the header styling, numbering, and generating the Table of Content
	var headers=document.getElementsByClassName("header");
	var h1Num=0, h2Num=0, h3Num=0;
	var toc="";
	if(document.getElementById("toc")){
		toc="<br><span style='color:#B22222; font-size:160%; font-weight: bold; text-shadow: 0.1px 0.1px 0.1px black;'>فهرست مطالب</span><br><br>";
	}
	for (var i = 0, l=headers.length; i<l; i++) {
		var header = headers[i];
		
		if(header.getAttribute("kind")=="h1"){
			h1Num++; h2Num=0; h3Num=0;
			var h1NumPersian=h1Num.toString().replace(/0/g,'۰').replace(/1/g,'۱').replace(/2/g,'۲').replace(/3/g,'۳').replace(/4/g,'۴').replace(/5/g,'۵').replace(/6/g,'۶').replace(/7/g,'۷').replace(/8/g,'۸').replace(/9/g,'۹');
			
			header.innerHTML="<span style='color:#483D8B; font-size:xx-large; font-weight:bold; text-shadow: 0.1px 0.1px 0.1px blue;' id='header-"+h1Num+"'>"+h1NumPersian+". "+header.innerHTML+"</span>";
			
			if(document.getElementById("toc")){
				toc+="<span id='H-"+h1Num+"' style='font-size:large;'><a href='#header-"+h1Num+"'>"+document.getElementById("header-"+h1Num).innerHTML+"</a></span><br>";
				
				header.innerHTML+=" <a href='#H-"+h1Num+"' style='font-size:large; color:cyan; border:1px groove cyan'>↩</a>"
			}
		}else if(header.getAttribute("kind")=="h2"){
			h2Num++; h3Num=0;
			var h2NumPersian=h1Num+".&hairsp;"+h2Num;		// &hairsp; is a hairspace that is used after the "." for "." to remain a "." between two numbers
			h2NumPersian=h2NumPersian.replace(/0/g,'۰').replace(/1/g,'۱').replace(/2/g,'۲').replace(/3/g,'۳').replace(/4/g,'۴').replace(/5/g,'۵').replace(/6/g,'۶').replace(/7/g,'۷').replace(/8/g,'۸').replace(/9/g,'۹');
			
			header.innerHTML="<span style='color:#B22222; font-size:x-large; font-weight:bold; text-shadow: 0.1px 0.1px 0.1px crimson;' id='header-"+h1Num+"."+h2Num+"'>"+h2NumPersian+". "+header.innerHTML+"</span>";
			
			if(document.getElementById("toc")){
				toc+="<span id='H-"+h1Num+"."+h2Num+"' style='margin-right:40px; font-size:medium;'><a href='#header-"+h1Num+"."+h2Num+"'>"+document.getElementById("header-"+h1Num+"."+h2Num).innerHTML+"</a></span><br>";
				
				header.innerHTML+=" <a href='#H-"+h1Num+"."+h2Num+"' style='font-size:medium; color:cyan; border:1px groove cyan'>↩</a>";
			}
		}else{
			h3Num++;
			var h3NumPersian=h1Num+".&hairsp;"+h2Num+".&hairsp;"+h3Num;		// &hairsp; is a hairspace that is used after the "." for "." to remain a "." between two numbers
			h3NumPersian=h3NumPersian.replace(/0/g,'۰').replace(/1/g,'۱').replace(/2/g,'۲').replace(/3/g,'۳').replace(/4/g,'۴').replace(/5/g,'۵').replace(/6/g,'۶').replace(/7/g,'۷').replace(/8/g,'۸').replace(/9/g,'۹');
			
			header.innerHTML="<span style='color:#DAA520; font-size:large; font-weight: bold; text-shadow: 0.1px 0.1px 0.1px rgb(128,128,128);' id='header-"+h1Num+"."+h2Num+"."+h3Num+"'>"+h3NumPersian+". "+header.innerHTML+"</span>";
			
			if(document.getElementById("toc")){
				toc+="<span id='H-"+h1Num+"."+h2Num+"."+h3Num+"' style='margin-right:80px; font-size:small;'><a href='#header-"+h1Num+"."+h2Num+"."+h3Num+"'>"+document.getElementById("header-"+h1Num+"."+h2Num+"."+h3Num).innerHTML+"</a></span><br>";
				
				header.innerHTML+=" <a href='#H-"+h1Num+"."+h2Num+"."+h3Num+"' style='font-size:small; color:cyan; border:1px groove cyan'>↩</a>";
			}
		}
	}
	if(document.getElementById("toc")){
		//toc+="<vskip><vskip>";
		document.getElementById("toc").innerHTML=toc;
	}
	
	
	
	// to handle the references, generating the list of references and managing how to cite them
	if(document.getElementById("listOfReferences")){
		
		// first start to add the content of the list of references, the main list is left empty to be populated later
		document.getElementById("listOfReferences").innerHTML="<br><span style='color:#B22222; font-size:160%; font-weight: bold; text-shadow: 0.1px 0.1px 0.1px black;' id='references-section'>مراجع</span>";
		if(document.getElementById("toc")){
			toc+="<span id='References'><a href='#references-section'>مراجع</a></span><br>";
			document.getElementById("toc").innerHTML=toc;
				
			document.getElementById("listOfReferences").innerHTML+=" <a href='#References' style='font-size:small; color:cyan; border:1px groove cyan'>↩</a>";
		}
		document.getElementById("listOfReferences").innerHTML+="<ol id='ref'></ol>";
		
		var draftListOfReferences=[];
		// then first write each reference in its proper style, then push it  as an item into the list of references:
		var references = document.getElementsByTagName("my-references");
		for (var i = 0; i < references.length; i++) {
			var reference=references[i];
			
			reference.innerHTML="<span author='"+reference.getAttribute("author")+"' year='"+reference.getAttribute("year")+"' id='"+reference.getAttribute("key")+"'>";	// author and year attributes are held as sorting the references would be with respect to them
			if(reference.getAttribute("author")){
				reference.innerHTML+=reference.getAttribute("author");
			}
			if(reference.getAttribute("year")){
				reference.innerHTML+=" ("+reference.getAttribute("year")+")";
			}
			if(reference.getAttribute("language")=="en"){
				if(reference.getAttribute("title")){
					reference.innerHTML+=" \"<strong>"+reference.getAttribute("title")+"</strong>\"";
				}
				if(reference.getAttribute("publisher")){
					reference.innerHTML+=", <em>"+reference.getAttribute("publisher")+"</em>";
				}
				if(reference.getAttribute("comment")){
					reference.innerHTML+=", "+reference.getAttribute("comment");
				}
			}else{
				if(reference.getAttribute("title")){
					reference.innerHTML+=" «<strong>"+reference.getAttribute("title")+"</strong>»";
				}
				if(reference.getAttribute("publisher")){
					reference.innerHTML+="، <em>"+reference.getAttribute("publisher")+"</em>";
				}
				if(reference.getAttribute("comment")){
					reference.innerHTML+="، "+reference.getAttribute("comment");
				}
			}
			reference.innerHTML+="</span>";
			
			draftListOfReferences.push(reference.innerHTML);	// populate the array draftListOfReferences
			
		}
		
		// to sort the list of references in authors and year of published works
		if(document.getElementById("listOfReferences").getAttribute("ordered")){
			draftListOfReferences.sort();		// Sort it , sorting first acts on <span author="..." year="..." id="key"> and then the rest of the reference details in the <span>, so it actually sorts first the authors, then the years, then ...
			//draftListOfReferences.reverse();	// to sort the array in descending form
		}
		
		var draftReference=document.createElement("span");
		for(var i=0, l=draftListOfReferences.length; i < l; i++){	// now populate the main ordered list of Refs
			draftReference.innerHTML=draftListOfReferences[i];
			var id=draftReference.querySelector("span").getAttribute("id");
			var reference=document.querySelector("[key='" + id + "']");
			if(reference.getAttribute("language")=="en"){
				//document.getElementById("ref").innerHTML += "<li dir='ltr'>"+draftListOfReferences[i]+"</li>";
				//document.getElementById("ref").innerHTML += "<li style='direction:ltr; text-align:left; float:left;'>"+draftListOfReferences[i]+"</li>";
				document.getElementById("ref").innerHTML += "<li style='text-align:left;'>"+draftListOfReferences[i]+"</li>";
			}else{
				document.getElementById("ref").innerHTML += "<li>"+draftListOfReferences[i]+"</li>";
			}
		}
		
		
		
		// now let handle the citations to the references listed in the list of references ... inspired by: http://folk.uib.no/plo092/katex/#saevik
		var txlist = document.getElementsByTagName("my-citation");
		for (var i = 0; i < txlist.length; i++) {
			var citeref = txlist[i];
			if(citeref.getAttribute("description")){
				citeref.innerHTML = "[<a href='#" + citeref.textContent + "'></a><span>،</span> "+citeref.getAttribute("description")+"]";
			}else{
				citeref.innerHTML = "[<a href='#" + citeref.textContent + "'></a>]";
			}
		}
		var lis = document.getElementById("ref").getElementsByTagName("li");
		for (var i = 0; i < lis.length; i++) {
			var id=lis[i].querySelector("span").getAttribute("id");
			var reference=document.querySelector("[key='" + id + "']");
			//alert(reference);
			var tx2list = document.querySelectorAll("my-citation a[href='#" + id + "']");
			var refNumber=(i+1).toString() .replace(/0/g,'۰').replace(/1/g,'۱').replace(/2/g,'۲').replace(/3/g,'۳').replace(/4/g,'۴').replace(/5/g,'۵').replace(/6/g,'۶').replace(/7/g,'۷').replace(/8/g,'۸').replace(/9/g,'۹');
			if(tx2list.length==0){
				alert("به مرجع "+refNumber+" ["+reference.getAttribute("shortRef")+"] در متن نوشتار اشاره‌ای انجام نگرفته است!");
			}
			for (var j = 0; j < tx2list.length; j++) {
				tx2list[j].innerHTML =refNumber;
				tx2list[j].setAttribute("title", reference.getAttribute("shortRef"));
				if(reference.getAttribute("language")=="en"){
					//tx2list[j].parentNode.querySelector("span").innerHTML=",";
					tx2list[j].setAttribute("dir", "ltr");     // this is required for the title of the link to be "ltr"!
				}
			}
		}
	}
	
	
	
	
	// to handle generating the list of Footnotes at the end
	var ftn="";
	if(ftnNum>=1){
		ftn="<br><span style='color:#B22222; font-size:160%; font-weight: bold; text-shadow: 0.1px 0.1px 0.1px black;' id='footnotes-endnots'>توضیحات</span>";
		if(document.getElementById("toc")){
			toc+="<span id='Endnotes'><a href='#footnotes-endnots'>توضیحات</a></span><br>";
			document.getElementById("toc").innerHTML=toc;
				
			ftn+=" <a href='#Endnotes' style='font-size:small; color:cyan; border:1px groove cyan'>↩</a>";
		}
		ftn+="<vskip><ol>"
		for(var i=1; i<=ftnNum; i++){
			//update the value of the variable 'ftn' to be shown at the end of the 'result' div
			ftn+="<li id='FTN-"+i+"'>"+document.getElementById("ftnHidden-"+i).innerHTML+" <a href='#ftn-"+i+"' style='color:cyan; border:1px groove cyan'>↩</a></li>";
		}
		ftn+="</ol>";
	}
	document.getElementById("result").innerHTML+=ftn;
	
	
	
	htmlExport=document.getElementById("result").innerHTML;	// the "result"'s content before applying MathJax, required for publishing the output as a new HTML
	
	//MathJax.Hub.Queue(["Typeset" , MathJax.Hub]); 		//recall MathJax to re-render the whole page!	
	//MathJax.Hub.Queue(["Typeset" , MathJax.Hub , "result"]);	//recall MathJax to re-render Only the results!
	MathJax.Hub.Queue(
		["resetEquationNumbers",MathJax.InputJax.TeX],	   // to reset the equation numberings at each compile
		["PreProcess",MathJax.Hub,"result"],
		["Reprocess",MathJax.Hub,"result"]
	);
	
}

// to show or hide footnotes inline on mouse-hover or mouse-leave
function showFootnoteInline(id){
	document.getElementById("ftnInlineHidden-"+id).style.display ="inline";
}
function hideFootnoteInline(id){
	document.getElementById("ftnInlineHidden-"+id).style.display ="none";
}





// -----------------------------------------------------------------------------
// defining proper PlaceHolders for the source and result div's ... // now that I am using a textarea instead of contenteditable div I can use the textarea's placeholder instead ...
/*
document.getElementById("source").onfocus=function(){
	sourceContent=document.getElementById("source").value;
	if (sourceContent=="متن کد ...") {
		document.getElementById("source").value="";
	}
};
document.getElementById("source").onblur=function(){
	sourceContent=document.getElementById("source").value.replace(/(\<br\>)+|(&nbsp;)+|\s+/g,"");
	if (sourceContent=="") {
		document.getElementById("source").value="متن کد ...";
		document.getElementById("result").innerHTML="نتیجه‌ی اجرای کد ...";
	}
};
*/



// -----------------------------------------------------------------------------
// defining function for working based on the Radio Buttons named "dir" ...

/*function changeDirection(){
	var direction=document.querySelector("input[name=dir]:checked").value;
	//alert(direction);
	document.getElementById("source").dir=direction;
};*/

// defining function for working based on the one single Checkbox instead of two radio buttons ...
function changeDirection(chb){
	if(chb.checked){
		document.getElementById("source").dir="rtl";
	}else{
		document.getElementById("source").dir="ltr";
	}
};



// -----------------------------------------------------------------------------
// open file


var openFile=document.getElementById("Openfile");

function openFunction(){
	openFile.click();	// this opens the file browser dialog for selecting a file to open
	return;
};

openFile.addEventListener('change', function() {
	/*
	var fileToLoad=openFile.value;
	document.getElementById("fileName").innerHTML="<span style='color:white; text-shadow: 2px 2px 2px black;''>عنوان فایل: </span><span style='color:crimson; font-weight: bold; text-shadow: 1px 1px 1px black; font-size:105%'>"+fileToLoad.replace(/(.txt)/,"")+"</span>";
	
	// to load the file selected
	//document.getElementById("source").value='<object type="text/html" data="'+fileToLoad+'" ></object>';
	
	var xhr = new XMLHttpRequest();
	xhr.open("GET", fileToLoad, true);
	xhr.onreadystatechange = function() {	// or	xhr.onload
		if (xhr.readyState == XMLHttpRequest.DONE ) {
			if (this.status >= 200 && this.status < 400) {
				// Success!
				document.getElementById("source").value = xhr.responseText;
			}
		}
	};
	xhr.send();
	*/
	var fileToLoad=openFile.files[0];			// the selected file itself as an object?
	var fileToLoadAddress=openFile.value;		// the relative or absolute address of the selected file
	
	document.getElementById("fileName").innerHTML="<span style='color:white; text-shadow: 2px 2px 2px black;''>عنوان فایل: </span><span style='color:crimson; font-weight: bold; text-shadow: 1px 1px 1px black; font-size:105%'>"+fileToLoadAddress  .split('\\').pop()  .replace(/(.txt)/,"")+"</span>";
	
	if(fileToLoad){
		var reader=new FileReader();
		reader.readAsText(fileToLoad, "UTF-8");
		reader.onload=function(event){ document.getElementById("source").value=event.target.result; };
		reader.onerror=function(event){ document.getElementById("source").value="بارگذاری فایل انتخاب شده ناموفق بود!"; };
	}	
});


// -----------------------------------------------------------------------------
// save the source file and the output as PDF, print the output as well
var today="بدون تاریخ";
var title="بدون عنوان";
function saveSource(){
	if(document.getElementById("today")){
		today=document.getElementById("today").innerHTML.replace(/\:/g,"٫");
	}
	if(document.getElementById("title")){
		title=document.getElementById("title").innerHTML;
	}
	// ------- if using  download.js
	download( document.getElementById("source").value  ,
		title+" (کد) - "+today+".txt"  ,  "text/html");	// دانلود نتیجه‌ی خروجی را هم موقتی در برنامه گذاشتم که اگر یک وقت برنامه عوض شد و دستورهای نوشتن کدها عوض شدند اگر چیزی نوشته بودم لااقل خروجی موجود باشد و خروجی را هم می‌توان در ورودی وارد کرد و بجز فرمول‌ها که فقط بار اول که کامپایل شوند درست نشان می‌دهند سایر بخش‌ها درست اجرا می‌شود چون عملاً .replace()ها کاری رویشان نمی‌کنند ...
	
	// ------- if not using  download.js, but saving comment would be lame, e.g. colors are not saved and etc.
	//var a = document.body.appendChild(document.createElement("a"));
	//a.download = "myContacts.js";
	//a.href = "data:text/html," + aaData;
	//a.click();
};
function saveHTML(){
	if(document.getElementById("today")){
		today=document.getElementById("today").innerHTML.replace(/\:/g,"٫");
	}
	if(document.getElementById("title")){
		title=document.getElementById("title").innerHTML;
	}
	// ------- if using  download.js
	download(
		'<!DOCTYPE html>\n'
		+'<html dir="rtl" lang="fa">\n'
		+'<head>\n'
		+'	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />\n'
		+'	<meta name="viewport" content="width=device-width, initial-scale=1.0">\n'
		+'	<title>'+title+'</title>\n'
		+'	<link rel="shortcut icon" type="image/ico" href="../0_main/images/icon.png">\n'
		
		+'	<script type="text/x-mathjax-config">\n'
		+'	MathJax.Hub.Config({\n'
		+'		//showProcessingMessages: false,\n'
		+'		//skipStartupTypeset: true, // to prevent rendering mathjax over the "source" div at the beginning!\n'
		+'		showMathMenu: true, messageStyle: "none",\n'
		+'		extensions: ["../0_main/MathJax/extensions/tex2jax.js"],\n'
		+'		//jax: ["input/TeX","output/SVG"],	//CommonHTML, HTML-CSS, PreviewHTML, SVG, NativeMML, PlainSource\n'
		+'		preJax: null,\n'
		+'		postJax: null,\n'
		+'		tex2jax:{\n'
		+'			//preview: [["img",{src: "../0_main/images/loader0.gif"}]],	//preview: "none",\n'
		+'			inlineMath: [ ["$","$"] ],	// ["$","$"],["\$","\$"],["\(","\)"],["\\(","\\)"]\n'
		+'			displayMath: [ ["$$","$$"] ],\n'
		+'			//processEscapes: true,	// for \$ to mean a common dollar sign, not a math delimiter\n'
		+'			//skipTags: ["script","noscript","style","textarea","pre","code","span"],\n'
		+'		},\n'
		+'		//"HTML-CSS": {\n'
		+'			//preferredFont: "Latin-Modern",\n'
		+'			//availableFonts: ["Latin-Modern","TeX"],\n'
		+'		//	undefinedFamily: "Niloofar,Arial,serif",\n'
		+'		//	linebreaks: { automatic: true },\n'
		+'		//	noReflows: false\n'
		+'			/*styles: {		// I don\'t know why it doesn\'t work quite properly\n'
		+'				".MathJax_Display": {\n'
		+'					"text-align": "center",\n'
		+'					margin: "1em 0em",\n'
		+'					color: "#FFFF88 !important"\n'
		+'				},\n'
		+'				".MathJax .merror": {\n'
		+'					"background-color": "#FFFF88",\n'
		+'					color: "#CC0000",\n'
		+'					border:  "1px solid #CC0000",\n'
		+'					padding: "1px 3px",\n'
		+'					"font-style": "normal",\n'
		+'					"font-size": "90%"\n'
		+'				}\n'
		+'			}*/\n'
		+'		//},\n'
		+'		TeX: {\n'
		+'			equationNumbers: {\n'
		+'				autoNumber: "AMS",\n'
		+'				formatNumber: function(n){\n'
		+'					return n.replace(/0/g,"۰").replace(/1/g,"۱").replace(/2/g,"۲").replace(/3/g,"۳").replace(/4/g,"۴").replace(/5/g,"۵").replace(/6/g,"۶").replace(/7/g,"۷").replace(/8/g,"۸").replace(/9/g,"۹");\n'
		+'				}\n'
		+'			}\n'
		+'		},\n'
		+'		/*unicode: {\n'
		+'			fonts: "\'Niloofar\',\'Sols\'"  // the default font list for unknown characters\n'
		+'		}*/\n'
		+'	});\n'
		+'	</scr'+'ipt>\n'
		+'	<!--<script type="text/javascript" async src="../0_main/MathJax/MathJax.js?config=TeX-AMS_SVG"></script>-->'
		+'	<!--<script type="text/javascript" async src="../0_main/MathJax-reduced/MathJax.js?config=TeX-AMS_SVG"></script>-->'
		+'		<!--/more beautiful math, bad farsi typesetting/: TeX-AMS_SVG  /  TeX-AMS_CHTML  /  TeX-AMS-MML_SVG  /  TeX-MML-AM_SVG-->'
		+'		<!--TeX-AMS_HTML  /  TeX-AMS-MML_HTMLorMML   /   TeX-MML-AM_HTMLorMML /  TeX-MML-AM_CHTML  -->'
		+'	<script type="text/javascript" src="../0_main/MathJax-single-file/MathJax.js?config=TeX-AMS_SVG"></script>'
		//+'	<script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js?config=TeX-AMS_HTML"></scr'+'ipt>\n'
		
		+'	<link type="text/css" rel="stylesheet" href="../0_main/myStyle.css"/>\n'
		+'</head>\n'
		+'<body>\n'
		
		+	htmlExport+'\n'
		
		+'	<script>\n'
		+'	// to show or hide footnotes inline on mouse-hover or mouse-leave\n'
		+'	function showFootnoteInline(id){\n'
		+'		document.getElementById("ftnInlineHidden-"+id).style.display ="inline";\n'
		+'	}\n'
		+'	function hideFootnoteInline(id){\n'
		+'		document.getElementById("ftnInlineHidden-"+id).style.display ="none";\n'
		+'	}\n'
		+'	</scr'+'ipt>\n'
		
		+'</body>\n'
		+'</html>' ,
		title+" (خروجی) - "+today+".html"  ,  "text/html");
	
	// ------- if not using  download.js, but saving comment would be lame, e.g. colors are not saved and etc.
	//var a = document.body.appendChild(document.createElement("a"));
	//a.download = "myContacts.js";
	//a.href = "data:text/html," + aaData;
	//a.click();
};
function savePDF(){
	/*
	MathJax.Hub.Queue(
		["resetEquationNumbers",MathJax.InputJax.TeX],	   // to reset the equation numberings at each compile
		["PreProcess",MathJax.Hub,"result"],
		["Reprocess",MathJax.Hub,"result"]
	);
	*/
	

	/* // a try to use jsPDF, but its unicode UTF-8 support is lame ...
	var doc = new jsPDF();
	//doc.fromHTML(document.getElementById("result").innerHTML, 15, 15, {'width': 170});
	var source =window.document.getElementsByTagName("body")[0]; //window.document.getElementById("result")[0];
	doc.fromHTML(source,15,15,{'width': 180});
	doc.text(20, 20, 'بسم الله، سلام!');
	doc.output("dataurlnewwindow");*/
	
	
	// a try to use pdfmake, but it doesn't generate pdf out of the div "result" yet, only some playing ...
	var docDefinition = {
		pageSize: 'A5',		//'4A0', '2A0', 'A0', 'A1', 'A2', 'A3', 'A4', 'A5', ... or {width:number, height:number}
		pageOrientation: 'landscape',	// default is 'portrait', but can also be 'landscape'
		pageMargins: [20,30,20,30 ],	// [left, top, right, bottom] or [horizontal, vertical] or just one number		
		header: {
			columns: [
				'Top Left Header',
				{ text: 'Top Right Header', alignment: 'right' }
			]
		},		
		footer: function(currentPage, pageCount) {
			return { text: currentPage.toString() + ' of ' + pageCount , alignment: (currentPage % 2) ? 'left' : 'right' };
		},		
		//background: 'simple text',
		
		content: [
			{
				text: 'This PDF is built making use of the "pdfmake", this library actually writes a PDF file from the biginning, that is, it doesn\'t print a div as PDF, but instead compiles that div as a PDF file, every html element which is a child of that div should be customized and configured and every font should be defined separately ..., the code commented in the file "notebook.html" in the definition of the function savePDF() is a try that automates compiling a div as a PDF file, but it has some shortcoming that I stopped using it until a later version of "pdfMake" might give a better clue for this ... See the net page for the datails!', fontSize: 16, bold: true, pageBreak: 'after', margin: [0,0,0,8]
			},
			{
				text: 'The first problem is that unfortunately the code as it is by now (maybe I could modify it) still needs jQuery! jQuery has been avioded in this project as this project is to remain minimalistic. ... The second problem is about defining new custom fonts. The default font is Roboto which has no UTF-8 glyph, so I can not compile any Persian or Arabic text, like if I write "بسم الله" which is the arabic translation of In the name of Allah you wil see only a blank space. The fonts are introduced to pdfMake via the file "vfs_fonts.js" and new fonts should be added to this file. But adding/removing fonts from this JS file requires usage of the "node.js" (and "nmp" as its package manager) and grunt as a package for it ... Doing so, finally I\'ll will have a large file for fonts beside the main font files used for the rest of the program ... its a waste of space, beside the waste of time for installing new fonts via node.js ... so I decided to wait for "pdfmake" to grow into a more mature level, so that it automatically recognize the fonts used in the file and embed only the glyphs used into the PDF file, maybe the PDF file would be smaller as well, I don\'t know ... yet, printing or saving as pdf by the browser itself seems far more efficient ...!', fontSize: 10, margin: [40,60,40,60], pageBreak: 'after'
			},
			{
				text: 'As for references, if I ever wanted to use the code introduced and build the PDF before pdfMake is matured enough:\n1. install node.js and npm via package manager (installing from the source seems difficult as it was giving me some errors, maybe some libs were missing); also see "https://howtonode.org/how-to-install-nodejs";\n2. refer to the following webpages for more details: "https://github.com/bpampuch/pdfmake/issues/33" and "https://bountify.co/javascript-create-pdf-with-chinese-characters".', fontSize: 12, margin: [40,60,40,60]
			}
		]
	};	
	pdfMake.createPdf(docDefinition).open();						// open the PDF in a new window	
	//pdfMake.createPdf(docDefinition).download('optionalName.pdf');	// download the PDF
	
	
	/*
	// a serious try with pdfmake, but unfortunately the code below still needs jQuery unless I modify it! Also for custom fonts yet it is not ideal, either because for any font to be used I should first update the file vfs_fonts.js through installing and usage of the "node.js" (and "nmp" its package manager) and grunt as a package for it, and because finally I will have a large file for fonts beside the main font files used for the rest of the program ... I decided to wait for "pdfmake" to be more mature ... yet, printing as pdf by the browser itself is more efficient ...!
	
	pdfForElement('result').open();						// open the PDF in a new window
	pdfForElement('result').download('optionalName.pdf');	// download the PDF
	function pdfForElement(id) {
		function ParseContainer(cnt, e, p, styles) {
			var elements = [];
			var children = e.childNodes;
			if (children.length != 0) {
				for (var i = 0; i < children.length; i++) p = ParseElement(elements, children[i], p, styles);
			}
			if (elements.length != 0) {
				for (var i = 0; i < elements.length; i++) cnt.push(elements[i]);
			}
			return p;
		}
		function ComputeStyle(o, styles) {
			for (var i = 0; i < styles.length; i++) {
				var st = styles[i].trim().toLowerCase().split(":");
				if (st.length == 2) {
					switch (st[0]) {
						case "font-size": {
							o.fontSize = parseInt(st[1]);
							break;
						}
						case "text-align": {
							switch (st[1]) {
								case "right":
									o.alignment = 'right';
									break;
								case "center":
									o.alignment = 'center';
									break;
							}
							break;
						}
						case "font-weight": {
							switch (st[1]) {
								case "bold":
									o.bold = true;
									break;
							}
							break;
						}
						case "text-decoration": {
							switch (st[1]) {
								case "underline":
									o.decoration = "underline";
									break;
							}
							break;
						}
						case "font-style": {
							switch (st[1]) {
								case "italic":
									o.italics = true;
									break;
							}
							break;
						}
					}
				}
			}
		}
		function ParseElement(cnt, e, p, styles) {
			if (!styles) styles = [];
			if (e.getAttribute) {
				var nodeStyle = e.getAttribute("style");
				if (nodeStyle) {
					var ns = nodeStyle.split(";");
					for (var k = 0; k < ns.length; k++) styles.push(ns[k]);
				}
			}
			switch (e.nodeName.toLowerCase()) {
				case "#text": {
					var t = {
						text: e.textContent.replace(/\n/g, "")
					};
					if (styles) ComputeStyle(t, styles);
					p.text.push(t);
					break;
				}
				case "b":
				case "strong": {
					//styles.push("font-weight:bold");
					ParseContainer(cnt, e, p, styles.concat(["font-weight:bold"]));
					break;
				}
				case "u": {
					//styles.push("text-decoration:underline");
					ParseContainer(cnt, e, p, styles.concat(["text-decoration:underline"]));
					break;
				}
				case "i": {
					//styles.push("font-style:italic");
					ParseContainer(cnt, e, p, styles.concat(["font-style:italic"]));
					//styles.pop();
					break;
					//cnt.push({ text: e.innerText, bold: false });
				}
				case "span": {
					ParseContainer(cnt, e, p, styles);
					break;
				}
				case "br": {
					p = CreateParagraph();
					cnt.push(p);
					break;
				}
				case "table": {
					var t = {
						table: {
							widths: [],
							body: []
						}
					}
					var border = e.getAttribute("border");
					var isBorder = false;
					if (border)
					if (parseInt(border) == 1) isBorder = true;
					if (!isBorder) t.layout = 'noBorders';
					ParseContainer(t.table.body, e, p, styles);
					var widths = e.getAttribute("widths");
					if (!widths) {
						if (t.table.body.length != 0) {
							if (t.table.body[0].length != 0)
								for (var k = 0; k < t.table.body[0].length; k++) t.table.widths.push("*");
						}
					} else {
						var w = widths.split(",");
						for (var k = 0; k < w.length; k++) t.table.widths.push(w[k]);
					}
					cnt.push(t);
					break;
				}
				case "tbody": {
					ParseContainer(cnt, e, p, styles);
					//p = CreateParagraph();
					break;
				}
				case "tr": {
					var row = [];
					ParseContainer(row, e, p, styles);
					cnt.push(row);
					break;
				}
				case "td": {
					p = CreateParagraph();
					var st = {
						stack: []
					}
					st.stack.push(p);
					var rspan = e.getAttribute("rowspan");
					if (rspan) st.rowSpan = parseInt(rspan);
					var cspan = e.getAttribute("colspan");
					if (cspan) st.colSpan = parseInt(cspan);
					ParseContainer(st.stack, e, p, styles);
					cnt.push(st);
					break;
				}
				case "div":
				case "p": {
					p = CreateParagraph();
					var st = {
						stack: []
					}
					st.stack.push(p);
					ComputeStyle(st, styles);
					ParseContainer(st.stack, e, p);
					cnt.push(st);
					break;
				}
				default: {
					console.log("Parsing for node " + e.nodeName + " not found");
					break;
				}
			}
			return p;
		}
		function ParseHtml(cnt, htmlText) {
			var html = $(htmlText.replace(/\t/g, "").replace(/\n/g, ""));
			var p = CreateParagraph();
			for (var i = 0; i < html.length; i++) ParseElement(cnt, html.get(i), p);
		}
		function CreateParagraph() {
			var p = {
				text: []
			};
			return p;
		}
		content = [];
		ParseHtml(content, document.getElementById(id).outerHTML);
		return pdfMake.createPdf({
			content: content
		});
	}
	*/
};
function printResult(){	// this function does nothing but calling the browsers printer, just like presseing Ctrl+p
	/*
	MathJax.Hub.Queue(
		["resetEquationNumbers",MathJax.InputJax.TeX],	   // to reset the equation numberings at each compile
		["PreProcess",MathJax.Hub,"result"],
		["Reprocess",MathJax.Hub,"result"]
	);
	*/
	
	/*resultContent = document.getElementById("result").innerHTML;
	var wholeBodyContents = document.body.innerHTML;
	document.body.innerHTML = resultContent;
	window.print();
	document.body.innerHTML = wholeBodyContents;*/
	
	//setTimeout(window.print, 3000);	//setTimeout is used to wait for math to be typesetted!
	window.print();
}



// -----------------------------------------------------------------------------
// prevent leaving the page


//$(window).bind('beforeunload', function(){
//	return 'شما در حال ترک نرم‌افزار هستید، آیا تمایل دارید یادداشت‌های خود را در صورت تغییر ذخیره نمایید؟';
//});	
window.onbeforeunload = function() {
	return "توصیه بر ذخیره‌ی داده‌ها پیش از حروج از نرم‌افزار است ... آیا اطمینان دارید می‌خواهید از نرم‌افزار خارج شوید؟!";
}	
//window.addEventListener("beforeunload", function(event) {
//	event.returnValue = "شما در حال ترک نرم‌افزار هستید، آیا تمایل دارید یادداشت‌های خود را در صورت تغییر ذخیره نمایید؟";
	//saveFunctioin();
//});